# Clone the PBL Plutus Starter Template

1. clone `https://gitlab.com/gimbalabs/ppbl-2023/ppbl-plutus-starter-2023`, but checkout `b6b645efc`
Using `git checkout b6b645efc` allows you to go back to the earliest version of the validator function as it may have changed
2. Launch `Nix` and obtain the corresponding version of the Plutus script
Changes made to a plutus validator script may affect the resulting address
3. Obtain the corresponding address for your Plutus Script
In the tutorial, we use `cardano-cli address build --payment-script-file ppbl-starter-validator.plutus --$testnet --out-file ppbl-starter-validator.addr`
This creates the address `ppbl-starter-validator.addr` whose value can be obtained using `echo $(cat ppbl-starter-validator.addr)`

## Your Task: Build Transactions using Datum
### Step 1: Make sure to have your node running using the Pre-prod network

### Step 2: Create wallets to process transactions

### Step 3: Either use a hashed or inlined Datum
When using a hashed value for your Datum, you need to use a hashing command and in the tutorial we also output a file
Using command `cardano-cli transaction hash-script-data --script-data-value 17 >> datum_17.hash`, we get a file containing the hash value. The value of the hash can be viewed using `echo $(cat datum_17.hash)`

### Step 4: Build transaction to lock funds at the smart contract address
- `s_address` being the smart contract address
- `address1` being the wallet used to pay for the fees and amount sent
- `txin2` being the UTXO used to pay for the transaction and also send the required amount
- `s_output3` being the amount in lovelace being sent
- `testnet` standing for "testnet-magic 1" as we are using the Preprod Network

The following command is used to send the funds and generate a temporary file to be signed
```bash
cardano-cli transaction build \
--babbage-era \
--$testnet \
--change-address $address1 \
--tx-in $txin2  \
--tx-out $s_address+$s_output3
--tx-out-datum-hash 4c54f47d69e097eed691c686ac18444a10d4abe934c311d0fffba9a3928f9e71 \
--out-file th_sep97.draft
```

You can also use an inline value. Replace `--tx-out-datum-hash 4c54f47d69e097eed691c686ac18444a10d4abe934c311d0fffba9a3928f9e71` with `--tx-out-inline-datum-value 17`

Sign the transaction:
```bash
cardano-cli transaction sign \
--signing-key-file payment.skey \
--$testnet \
--tx-body-file th_sep97.draft \
--out-file th_sep97.signed
```

And submit it:
`cardano-cli transaction submit --tx-file th_sep97.signed --$testnet`

### Step 5: Retrieve the funds held at the smart contract
- `tx_c1` being the Smart Contract UTXO to be consummed
- `tx_f1` being the UTXO from Wallet2 used to pay for the transaction and receive the change
- `tx_col1` being the UTXO from Wallet2 used as a collateral
- `plutusscriptinuse` being the Plutus Script (xyz.plutus) used to obtain the smart contract address

The following command is used to retreive funds held at the script (you need to get the most recent protocol parameters as shown in the video)
```bash
cardano-cli transaction build \
--babbage-era \
--$testnet \
--tx-in $tx_f1 \
--tx-in-collateral $tx_col1 \
--tx-in $tx_c1
--tx-in-script-file $plutusscriptinuse \
--tx-in-inline-datum-value 17 \
--tx-in-redeemer-value 17 \
--change-address $address2
--protocol-params-file protocol.json \
--out-file rt_sep922.draft
```

For inline Datum, `--tx-in-inline-datum-value 17` must be replaced by `--tx-in-inline-datum-present`
 (17 may be the correct value, but the validation does not expect a datum when it is inlined).


import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;